package aerogen;

import java.util.Random;

import org.bukkit.Material;
import org.bukkit.TreeType;
import org.bukkit.block.Biome;

public class BiomeDescription {

	private static BiomeDescription standard = new BiomeDescription();
	private static BiomeDescription desert = new BiomeDescription();
	private static BiomeDescription extreme_hills = new BiomeDescription();
	private static BiomeDescription forest = new BiomeDescription();
	private static BiomeDescription frozen_ocean = new BiomeDescription();
	private static BiomeDescription frozen_river = new BiomeDescription();
	private static BiomeDescription hell = new BiomeDescription();
	private static BiomeDescription ice_desert = new BiomeDescription();
	private static BiomeDescription ice_mountains = new BiomeDescription();
	private static BiomeDescription ice_plains = new BiomeDescription();
	private static BiomeDescription mushroom_island = new BiomeDescription();
	private static BiomeDescription mushroom_shore = new BiomeDescription();
	private static BiomeDescription ocean = new BiomeDescription();
	private static BiomeDescription plains = new BiomeDescription();
	private static BiomeDescription rainforest = new BiomeDescription();
	private static BiomeDescription river = new BiomeDescription();
	private static BiomeDescription savanna = new BiomeDescription();
	private static BiomeDescription seasonal_forest = new BiomeDescription();
	private static BiomeDescription shrubland = new BiomeDescription();
	private static BiomeDescription sky = new BiomeDescription();
	private static BiomeDescription swampland = new BiomeDescription();
	private static BiomeDescription taiga = new BiomeDescription();
	private static BiomeDescription tundra = new BiomeDescription();
	
	static {
		
		//Desert
		desert.islandRockMaterial = (byte) Material.SANDSTONE.getId();
		desert.islandSoilMaterial = (byte) Material.SAND.getId();
		desert.islandSurfaceMaterial = (byte) Material.SAND.getId();
		desert.lakeChance = 0.0;
		desert.treeDensity = 0.0;
		desert.cliffs = true;
		desert.islandSoilDepth = 0.5;
		desert.roughness = 6.0;
		desert.frequency = 0.3;
		desert.cactusDensity = 0.005;
		desert.shrubDensity = 0.02;
		desert.shrubType = new byte[] {0};
		desert.shrubTypeChance = new double[] {1.0};
		desert.islandSizeMin = 64;
		desert.chanceOfIsland = 0.03;
		desert.pondWaterChance = 0.0;
		desert.pondLavaChance = 0.0;
		
		//Extreme Hills
		extreme_hills.treeDensity = 0.003;
		extreme_hills.treeType = new TreeType[] {TreeType.TREE};
		extreme_hills.treeTypeChance = new double[] {1.0};
		extreme_hills.lakeChance = 0.05;
		extreme_hills.roughness = 20.0;
		extreme_hills.frequency = 0.6;
		extreme_hills.islandSizeMin = 64;
		extreme_hills.islandSizeMax = 128;
		extreme_hills.shrubDensity = 0.01;
		extreme_hills.shrubType = new byte[] {1, 2};
		extreme_hills.shrubTypeChance = new double[] {0.7, 0.3};
		extreme_hills.pumpkinDensity = 0.00001;
		extreme_hills.watermelonDensity = 0.00001;
		extreme_hills.pondWaterChance = 0.0;
		extreme_hills.pondLavaChance = 0.0;
		
		//Forest
		forest.cliffs = true;
		forest.roughness = 8.0;
		forest.treeDensity = 0.01;
		forest.lakeChance = 0.2;
		forest.shrubDensity = 0.1;
		forest.shrubType = new byte[] {1, 2};
		forest.shrubTypeChance = new double[] {0.7, 0.3};
		forest.pumpkinDensity = 0.00001;
		forest.watermelonDensity = 0.00001;
		
		//Frozen Ocean
		frozen_ocean.cliffs = false;
		frozen_ocean.lakeChance = 1.0;
		frozen_ocean.treeDensity = 0.001;
		frozen_ocean.treeType = new TreeType[] {TreeType.TALL_REDWOOD};
		frozen_ocean.treeTypeChance = new double[] {1.0};
		frozen_ocean.roughness = 0.0;
		frozen_ocean.snow = true;
		frozen_ocean.islandFluidMaterial = (byte) Material.ICE.getId();
		frozen_ocean.chanceOfIsland = 0.001;
		frozen_ocean.islandSizeMin = 128;
		frozen_ocean.islandSizeMax = 256;
		
		//Frozen River
		frozen_river.cliffs = false;
		frozen_river.lakeChance = 0.9;
		frozen_river.treeDensity = 0.002;
		frozen_river.treeType = frozen_ocean.treeType;
		frozen_river.treeTypeChance = frozen_ocean.treeTypeChance;
		frozen_river.roughness = 3.0;
		frozen_river.frequency = 0.3;
		frozen_river.snow = true;
		frozen_river.islandFluidMaterial = (byte) Material.ICE.getId();
		
		//Hell		
		hell.cliffs = true;
		hell.cliffHeightMin = 5;
		hell.cliffHeightMax = 10;
		hell.lakeChance = 0.7;
		hell.treeDensity = 0.0;
		hell.roughness = 10.0;
		hell.frequency = 4.0;
		hell.islandFluidMaterial = (byte) Material.LAVA.getId();
		hell.islandLakeBedMaterial = (byte) Material.SOUL_SAND.getId();
		hell.islandSoilMaterial = (byte) Material.NETHERRACK.getId();
		hell.islandRockMaterial = (byte) Material.NETHERRACK.getId();
		hell.islandSurfaceMaterial = (byte) Material.NETHERRACK.getId();
		hell.islandAltitudeMax = 64;
		hell.islandAltitudeMax = 24;		
		hell.shrubDensity = 0.002;
		hell.shrubType = new byte[] {0};
		hell.shrubTypeChance = new double[] {1.0};
		
		//Ice Desert
		ice_desert.cliffs = true;
		ice_desert.lakeChance = 0.0;
		ice_desert.treeDensity = 0.002;
		ice_desert.treeType = frozen_ocean.treeType;
		ice_desert.treeTypeChance = frozen_ocean.treeTypeChance;
		ice_desert.roughness = 6.0;
		ice_desert.frequency = 0.3;
		ice_desert.snow = true;
		ice_desert.islandRockMaterial = (byte) Material.SANDSTONE.getId();
		ice_desert.islandSoilMaterial = (byte) Material.SAND.getId();
		ice_desert.islandSurfaceMaterial = (byte) Material.SAND.getId();
		ice_desert.islandSoilDepth = 0.5;
		
		//Ice Mountains
		ice_mountains.treeDensity = 0.003;
		ice_mountains.treeType = frozen_ocean.treeType;
		ice_mountains.treeTypeChance = frozen_ocean.treeTypeChance;
		ice_mountains.lakeChance = 0.05;
		ice_mountains.roughness = 20.0;
		ice_mountains.frequency = 0.4;
		ice_mountains.islandSizeMin = 64;
		ice_mountains.islandSizeMax = 128;
		ice_mountains.islandFluidMaterial = (byte) Material.ICE.getId();
		ice_mountains.islandSurfaceMaterial = (byte) Material.SNOW_BLOCK.getId();
		ice_mountains.islandSoilMaterial = (byte) Material.STONE.getId();
		ice_mountains.islandRockMaterial = (byte) Material.STONE.getId();
		ice_mountains.snow = true;
		ice_mountains.pondWaterChance = 0.0;
		
		//Ice Plains
		ice_plains.cliffs = true;
		ice_plains.lakeChance = 0.01;
		ice_plains.treeDensity = 0.001;
		ice_plains.treeType = new TreeType[] {TreeType.TALL_REDWOOD};
		ice_plains.treeTypeChance = new double[] {1.0};
		ice_plains.roughness = 2.0;
		ice_plains.frequency = 0.3;
		ice_plains.snow = true;
		ice_plains.islandFluidMaterial = (byte) Material.ICE.getId();
		
		//Mushroom Island
		mushroom_island.cliffs = true;
		mushroom_island.lakeChance = 0.2;
		mushroom_island.treeDensity = 0.007;
		mushroom_island.roughness = 8.0;
		mushroom_island.frequency = 0.3;
		mushroom_island.islandSurfaceMaterial = (byte) Material.MYCEL.getId();
		mushroom_island.treeType = new TreeType[] {TreeType.BROWN_MUSHROOM, TreeType.RED_MUSHROOM};
		mushroom_island.treeTypeChance = new double[] {0.5, 0.5};
		mushroom_island.mushroomDensity = 0.01;
		
		//Mushroom Shore
		mushroom_shore.cliffs = false;
		mushroom_shore.lakeChance = 0.7;
		mushroom_shore.treeDensity = 0.003;
		mushroom_shore.roughness = 4.0;
		mushroom_shore.frequency = 0.3;
		mushroom_shore.islandSurfaceMaterial = (byte) Material.MYCEL.getId();
		mushroom_shore.treeType = mushroom_island.treeType;
		mushroom_shore.treeTypeChance = mushroom_island.treeTypeChance;
		mushroom_shore.mushroomDensity = 0.01;
		
		//Ocean
		ocean.cliffs = false;
		ocean.lakeChance = 1.0;
		ocean.treeDensity = 0.002;
		ocean.treeType = extreme_hills.treeType;
		ocean.treeTypeChance = extreme_hills.treeTypeChance;
		ocean.roughness = 0.0;
		ocean.chanceOfIsland = 0.001;
		ocean.islandSizeMin = 128;
		ocean.islandSizeMax = 256;
		
		//Plains
		plains.lakeChance = 0.01;
		plains.treeDensity = 0.001;
		plains.roughness = 2.0;
		plains.frequency = 0.3;
		plains.shrubDensity = 0.3;
		plains.pumpkinDensity = 0.00001;
		plains.watermelonDensity = 0.00001;
		
		//Rain Forest
		rainforest.cliffs = true;
		rainforest.roughness = 8.0;
		rainforest.frequency = 0.2;
		rainforest.treeDensity = 0.014;
		rainforest.treeType = new TreeType[] {TreeType.TREE, TreeType.BIG_TREE, TreeType.REDWOOD};
		rainforest.treeTypeChance = new double[] {0.4, 0.2, 0.4};
		rainforest.lakeChance = 0.4;
		rainforest.islandSizeMin = 64;
		rainforest.islandSizeMax = 128;
		rainforest.shrubDensity = 0.1;
		rainforest.shrubType = new byte[] {1, 2};
		rainforest.shrubTypeChance = new double[] {0.7, 0.3};
		rainforest.pumpkinDensity = 0.00002;
		rainforest.watermelonDensity = 0.00002;
				
		//River
		river.cliffs = false;
		river.lakeChance = 0.9;
		river.treeDensity = 0.001;
		river.treeType = extreme_hills.treeType;
		river.treeTypeChance = extreme_hills.treeTypeChance;
		river.roughness = 3.0;
		river.frequency = 0.3;
		river.shrubDensity = 0.01;
		river.shrubType = new byte[] {1, 2};
		river.shrubTypeChance = new double[] {0.4, 0.6};
		river.pumpkinDensity = 0.00001;
		river.watermelonDensity = 0.000012;
		
		//Savanna
		savanna.cliffs = true;
		savanna.lakeChance = 0.01;
		savanna.treeDensity = 0.001;
		savanna.treeType = extreme_hills.treeType;
		savanna.treeTypeChance = extreme_hills.treeTypeChance;
		savanna.roughness = 4.0;
		savanna.frequency = 0.2;
		savanna.shrubDensity = 0.6;
		savanna.shrubType = new byte[] {1, 2};
		savanna.shrubTypeChance = new double[] {0.9, 0.1};
		savanna.pumpkinDensity = 0.00002;
		savanna.watermelonDensity = 0.00002;
		
		//Seasonal Forest
		seasonal_forest.cliffs = true;
		seasonal_forest.roughness = 8.0;
		seasonal_forest.treeDensity = 0.01;
		seasonal_forest.treeType = new TreeType[] {TreeType.TREE, TreeType.BIG_TREE, TreeType.BIRCH};
		seasonal_forest.treeTypeChance = new double[] {0.45, 0.1, 0.45};
		seasonal_forest.lakeChance = 0.6;
		seasonal_forest.shrubDensity = 0.1;
		seasonal_forest.shrubType = new byte[] {1, 2};
		seasonal_forest.shrubTypeChance = new double[] {0.7, 0.3};
		seasonal_forest.pumpkinDensity = 0.00001;
		seasonal_forest.watermelonDensity = 0.00001;
		
		//Shrubland
		shrubland.cliffs = true;
		shrubland.lakeChance = 0.01;
		shrubland.treeDensity = 0.001;
		shrubland.treeType = extreme_hills.treeType;
		shrubland.treeTypeChance = extreme_hills.treeTypeChance;
		shrubland.roughness = 4.0;
		shrubland.frequency = 0.2;
		shrubland.shrubDensity = 0.8;
		shrubland.shrubType = new byte[] {1, 2};
		shrubland.shrubTypeChance = new double[] {0.9, 0.1};
		shrubland.pumpkinDensity = 0.00002;
		shrubland.watermelonDensity = 0.00002;
		
		//Swampland
		swampland.cliffs = true;
		swampland.cliffHeightMin = 2;
		swampland.cliffHeightMax = 4;
		swampland.lakeChance = 0.9;
		swampland.treeDensity = 0.003;
		swampland.treeType = extreme_hills.treeType;
		swampland.treeTypeChance = extreme_hills.treeTypeChance;
		swampland.roughness = 4.0;
		swampland.frequency = 0.2;
		swampland.islandLakeBedDirt = (byte) Material.DIRT.getId();
		swampland.shrubDensity = 0.3;
		swampland.shrubType = new byte[] {1};
		swampland.shrubTypeChance = new double[] {1.0};
		swampland.pumpkinDensity = 0.00001;
		swampland.watermelonDensity = 0.00001;
		
		//Taiga
		taiga.cliffs = true;
		taiga.lakeChance = 0.01;
		taiga.treeDensity = 0.001;
		taiga.treeType = extreme_hills.treeType;
		taiga.treeTypeChance = extreme_hills.treeTypeChance;
		taiga.roughness = 4.0;
		taiga.frequency = 0.2;
		taiga.shrubDensity = 0.6;
		taiga.shrubType = new byte[] {1, 2};
		taiga.shrubTypeChance = new double[] {0.9, 0.1};
		taiga.pumpkinDensity = 0.00002;
		taiga.watermelonDensity = 0.00002;
		
		//Tundra
		tundra.cliffs = true;
		tundra.roughness = 8.0;
		tundra.treeDensity = 0.015;
		tundra.lakeChance = 0.6;
		tundra.snow = true;
		tundra.islandFluidMaterial = (byte) Material.ICE.getId();
		tundra.treeType = frozen_ocean.treeType;
		tundra.treeTypeChance = frozen_ocean.treeTypeChance;
		
	}
	
	
	public static BiomeDescription getDescription(Biome mcBiome) {
		switch(mcBiome) {
			case DESERT: return desert;
			case EXTREME_HILLS: return extreme_hills;
			case FOREST: return forest;
			case FROZEN_OCEAN : return frozen_ocean;
			case FROZEN_RIVER : return frozen_river;
			case HELL : return hell;
			case ICE_DESERT : return ice_desert;
			case ICE_MOUNTAINS : return ice_mountains;
			case ICE_PLAINS : return ice_plains;
			case MUSHROOM_ISLAND : return mushroom_island;
			case MUSHROOM_SHORE : return mushroom_shore;
			case OCEAN : return ocean;
			case PLAINS : return plains;
			case RAINFOREST : return rainforest;
			case RIVER : return river;
			case SAVANNA : return savanna;
			case SEASONAL_FOREST : return seasonal_forest;
			case SHRUBLAND : return shrubland;
			case SKY : return sky;
			case SWAMPLAND : return swampland;
			case TAIGA : return taiga;
			case TUNDRA : return tundra;
			default : return standard;
		}
	}
	
	//Basic Island Appearance
	public double chanceOfIsland = 0.05;
	public int islandSizeMin = 32;
	public int islandSizeMax = 256;
	public double islandSquareRegularity = 0.5;
	public int islandHeightMin = 28;
	public int islandHeightMax = 128;
	public double islandHeightRatio = 0.4;
	public double islandHeightRegularity = 0.8;
	public int islandAltitudeMin = 0;
	public int islandAltitudeMax = 128;
	
	//Island Composition
	public byte islandRockMaterial = (byte) Material.STONE.getId();
	public byte islandSoilMaterial = (byte) Material.DIRT.getId();
	public byte islandSurfaceMaterial = (byte) Material.GRASS.getId();
	public byte islandLakeBedMaterial = (byte) Material.SAND.getId();
	public byte islandLakeBedDirt = (byte) Material.SAND.getId();
	public byte islandFluidMaterial = (byte) Material.WATER.getId();
	public byte islandSnowMaterial = (byte) Material.SNOW.getId();
	
	//Terrain Features
	public double lakeChance = 0.1;
	public boolean snow = false;
	public boolean cliffs = false;
	public int cliffHeightMin = 4;
	public int cliffHeightMax = 8;
	public double roughness = 8.0;
	public double frequency = 0.5;
	public double islandSoilDepth = 0.3;
	public double erosionChance = 0.2;
	public double pondWaterChance = 0.0002;
	public double pondLavaChance = 0.0001;
	
	//Plant life
	public double treeDensity = 0.005;
	public TreeType[] treeType = new TreeType[] {TreeType.TREE, TreeType.BIG_TREE};
	public double[] treeTypeChance = new double[] {0.8, 0.2};
	public double reedDensity = 0.0;
	public int readClusterMin = 2;
	public int readClusterMax = 5;
	public double cactusDensity = 0.0;
	public double shrubDensity = 0.02;
	public byte[] shrubType = new byte[] {1, 2};
	public double[] shrubTypeChance = new double[] {0.7, 0.3};
	public double flowerDensity = 0.0;
	public double flowerClusterIsRedChance = 0.5;
	public int flowerClusterMin = 3;
	public int flowerClusterMax = 7;
	public double mushroomDensity = 0.0;
	public double mushroomClusterIsRedChance = 0.5;
	public int mushroomClusterMin = 3;
	public int mushroomClusterMax = 5;
	public double watermelonDensity = 0.0;
	public int watermelonClusterMin = 3;
	public int watermelonClusterMax = 5;
	public double pumpkinDensity = 0.0;
	public int pumpkinClusterMin = 3;
	public int pumpkinClusterMax = 5;
	
	//Cave features
	public CaveDescription caveDescription = new CaveDescription();
	
	//Extras
	public double liquidFallChance = 0.001;
	public double lavaFallChance = 0.5;
	
	//Ores	
	public double[] oreTypeChance = new double[] {0.002, 0.001, 0.001, 0.0005, 0.0005, 0.0005, 0.0002};
	public double[] oreTypeMinDepth = new double[] {0.0, 0.2, 0.3, 0.6, 0.7, 0.7, 0.9};
	public byte[] oreTypeMaterial = new byte[] {13, 16, 15, 14, 73, 21, 56};
	public int[] oreTypeVeinMin = new int[] {5, 6, 4, 3, 5, 3, 2};
	public int[] oreTypeVeinMax = new int[] {16, 22, 24, 6, 7, 6, 5};
	
	
	public boolean doCreateIsland(Random random) {
		return random.nextDouble() < chanceOfIsland;
	}
	
	public Int3D getPosition(Random random, int chunkX, int chunkZ, Int3D size) {
		int x = chunkX*16 + random.nextInt(16)-size.x/2;
		int y = islandAltitudeMin + random.nextInt(islandAltitudeMax-size.y-islandAltitudeMin+1);
		int z = chunkZ*16 + random.nextInt(16)-size.z/2;
		return new Int3D(x, y, z);
	}
	
	public Int3D getDimensions(Random random) {
		int airSpace = getAirSpace();
		int length = islandSizeMin + weightedRand(random, islandSizeMax-islandSizeMin+1, 6.0);
		int bredth = islandSizeMin + weightedRand(random, islandSizeMax-islandSizeMin+1, 6.0);
		bredth = (int) (islandSquareRegularity*(double)length + (1.0-islandSquareRegularity)*(double)bredth);
		int height = islandHeightMin + airSpace + weightedRand(random, islandHeightMax-islandHeightMin+1, 6.0);
		height = (int) (islandHeightRegularity*(double)(length+bredth)/2.0*islandHeightRatio + (1.0-islandHeightRegularity)*(double)height);
		if(height < airSpace + islandHeightMin) height = airSpace + islandHeightMin;
		return new Int3D(length, height, bredth);
	}

	public int getAirSpace() {
		int airSpace = (int) roughness;
		if(cliffs) airSpace += cliffHeightMax;
		if(treeDensity > 0) airSpace += 10;
		return airSpace;
	}

	private int weightedRand(Random random, int i, double d) {
		return (int) (Math.pow(random.nextDouble(), d)*(i+1));
	}

	public boolean doLake(Random random) {
		return random.nextDouble() < lakeChance;
	}

	public int rollCliffHeight(Random random) {
		return random.nextInt(cliffHeightMax-cliffHeightMin+1)+cliffHeightMin;
	}

	public boolean rollTree(Random random) {
		return random.nextDouble() < treeDensity;
	}

	public TreeType rollTreeType(Random random) {
		double total = 0.0;
		for(int i = 0; i < treeTypeChance.length; i++) {
			total += treeTypeChance[i];
		}
		double d = random.nextDouble()*total;
		double chance = 0.0;
		for(int i = 0; i < treeType.length; i++) {
			if(d < chance+treeTypeChance[i]) {
				return treeType[i];
			} else {
				chance += treeTypeChance[i];
			}
		}
		return TreeType.TREE;
	}

	public boolean rollErode(Random random) {
		return random.nextDouble() < erosionChance;
	}

	public boolean rollShrub(Random random) {
		return random.nextDouble() < shrubDensity;
	}	
	
	public byte rollShrubType(Random random) {
		double total = 0.0;
		for(int i = 0; i < shrubTypeChance.length; i++) {
			total += shrubTypeChance[i];
		}
		double d = random.nextDouble()*total;
		double chance = 0.0;
		for(int i = 0; i < shrubType.length; i++) {
			if(d < chance+shrubTypeChance[i]) {
				return shrubType[i];
			} else {
				chance += shrubTypeChance[i];
			}
		}
		return (byte) 1;
	}

	public boolean rollReed(Random random) {
		return random.nextDouble() < reedDensity;
	}

	public boolean rollCactus(Random random) {
		return random.nextDouble() < cactusDensity;
	}

	public boolean rollFlower(Random random) {
		return random.nextDouble() < flowerDensity;
	}
	
	public boolean rollFlowerType(Random random) {
		return random.nextDouble() < flowerClusterIsRedChance;
	}
	
	public int rollFlowerClusterSize(Random random) {
		return random.nextInt(flowerClusterMax-flowerClusterMin+1) + flowerClusterMin;
	}
	
	public boolean rollMushroom(Random random) {
		return random.nextDouble() < mushroomDensity;
	}
	
	public boolean rollMushroomType(Random random) {
		return random.nextDouble() < mushroomClusterIsRedChance;
	}
	
	public int rollMushroomClusterSize(Random random) {
		return random.nextInt(mushroomClusterMax-mushroomClusterMin+1) + mushroomClusterMin;
	}

	public boolean rollPumpkin(Random random) {
		return random.nextDouble() < pumpkinDensity;
	}
	
	public int rollPumpkinClusterSize(Random random) {
		return random.nextInt(pumpkinClusterMax-pumpkinClusterMin+1) + pumpkinClusterMin;
	}
	
	public boolean rollWatermelon(Random random) {
		return random.nextDouble() < watermelonDensity;
	}
	
	public int rollWatermelonClusterSize(Random random) {
		return random.nextInt(watermelonClusterMax-watermelonClusterMin+1) + watermelonClusterMin;
	}

	public int getMaximumCaveSpace(int islandMass) {
		return (int) (caveDescription.cavePercentage * islandMass);
	}

	public int rollOreVein(Random random, double depth) {
		for(int i = 0; i < oreTypeChance.length; i++) {
			if(depth < 1.0-oreTypeMinDepth[i] && random.nextDouble() < oreTypeChance[i]) {
				return i;
			}
		}
		return -1;
	}

	public int rollOreVeinSize(Random random, int type) {
		return random.nextInt(oreTypeVeinMax[type]-oreTypeVeinMin[type]+1)+oreTypeVeinMin[type];
	}

	public byte getOreMaterial(int type) {
		return oreTypeMaterial[type];
	}

	public boolean rollWaterPond(Random random) {
		return random.nextDouble() < pondWaterChance;
	}
	
	public boolean rollLavaPond(Random random) {
		return random.nextDouble() < pondLavaChance;
	}
	
}
